package newsTicker;

import java.io.File;

public class ArgsParser {
	
	private int 	geschwindigkeit;
	private char	laufrichtung;
	private int		breite;
	private int 	hoehe;
	private int 	schriftgroesse;
	private File 	dateiname;
	
	public ArgsParser(String[] argumente) {
		
		// Durchlaufe alle Argumente
		for (int nr=0; nr < argumente.length; nr++) {
			// und pruefe alle Argument-Moeglichkeiten

			if ( argumente[nr].compareToIgnoreCase("--geschwindigkeit") == 0 ) { 
				geschwindigkeit = Integer.parseInt( argumente[nr+1] );
			}
			if ( argumente[nr].compareToIgnoreCase("--laufrichtung") == 0 ) {
				laufrichtung = argumente[nr+1].charAt(0);
			}
			if ( argumente[nr].compareToIgnoreCase("--breite") == 0 ) {
				breite = Integer.parseInt( argumente[nr+1] );
			}
			if ( argumente[nr].compareToIgnoreCase("--hoehe") == 0 ) {
				hoehe = Integer.parseInt( argumente[nr+1] );
			}
			if ( argumente[nr].compareToIgnoreCase("--datei") == 0 ) {
				dateiname = new File( "./" + argumente[nr+1] ); 
			}
			if ( argumente[nr].compareToIgnoreCase("--schriftgroesse") == 0 ) {
				schriftgroesse = Integer.parseInt( argumente[nr+1] ); 
			}
			// Mit --help oder -h soll ein kurzer Hilfe-Text zu den Argumenten angezeigt werden
			if ( argumente[nr].compareToIgnoreCase("--help") == 0 ||
				 argumente[nr].compareToIgnoreCase("-h")     == 0 ) {
				System.out.println("NewsTicker.  Moegliche Argumente:\n" +
								   "   --geschwindigkeit [1-9]\n" + 
								   "   --laufrichtung    [h/v]\n" +
								   "   --breite          [breite in pixel]\n" + 
								   "   --hoehe           [hoehe in pixeln]\n" +
								   "   --datei           [xml-dateiname(rss/rdf)]\n" +
								   "   --schriftgroesse  [in punkten]\n" +
								   "   --help            diese Hilfe.\n\n");
				// Falls mit "--help"/"-h" die Hilfe angefordert wurde Programm jetzt beenden.
				System.exit(0);
			}
		}
		// Falls einzelne Werte nicht geparst werden konnten: setze Standardwerte
		if ( geschwindigkeit<1 || geschwindigkeit>9 ) geschwindigkeit = Standard.geschwindigkeit;
		if ( laufrichtung!='h' && laufrichtung!='v' ) laufrichtung = Standard.laufrichtung;
		if ( breite == 0 ) breite = Standard.breite; 
		if ( hoehe == 0 ) hoehe = Standard.hoehe; 		
		if ( dateiname == null || !dateiname.canRead() ) dateiname = Standard.dateiname; 
		if ( schriftgroesse == 0 ) schriftgroesse = Standard.schriftGroesse; 		
	}

	public int  	getGeschwindigkeit() {
		return geschwindigkeit;
	}
	public char  	getLaufrichtung() {
		return laufrichtung;
	}
	public int  	getBreite() {
		return breite;
	}
	public int  	getHoehe() {
		return hoehe;
	}
	public String  	getDateiname() {
		return dateiname.toString();
	}
	public int  	getSchriftgroesse() {
		return schriftgroesse;
	}
}
