package newsTicker;
import java.awt.Color;
import newsTicker.Nachricht;

public class HTMLParser {
	
	private int 		geschwindigkeit;
	private char  		laufrichtung;
	private Nachricht[] nachrichten;
	
	// Konstruktor - erledigt das komplette einlesen der HTML-Parameter
	public HTMLParser(NewstickerApplet applet) {

		int anzahlNews = 0;

		// News-Anzahl ermitteln 
		while ( (applet.getParameter( "titel"+anzahlNews )) != null ) { anzahlNews++; }
		
		// falls keine gueltigen News: Erzeuge zwei Fake-News
		if ( anzahlNews == 0 ) {  
			nachrichten = new Nachricht[ anzahlNews=2 ];
			nachrichten[0] = new Nachricht("Es wurden _keine_ News ...", "http://davey.de");
			nachrichten[1] = new Nachricht("...dem Programm uebergeben", "http://davey.de");
			
		// sonst lese uebergeben News & Konfig. aus
		} else {   
			
			// Nachrichten-Array anlegen
			nachrichten = new Nachricht[ anzahlNews ];
			
			for ( int nr=0; nr < anzahlNews; nr++ ) { 

				// Nachrichten-Objekt mit Titel & Link anlegen
				nachrichten[nr] = new Nachricht( applet.getParameter("titel"+nr), applet.getParameter("link"+nr) );

				// Schriftgroesse fuer diese Nachricht anpassen ?
				if ( applet.getParameter("schriftgroesse"+nr) != null ) {
					int schriftgroesse = Integer.parseInt( applet.getParameter("schriftgroesse"+nr) );
					if (  schriftgroesse != 0 ) nachrichten[nr].setSchriftGroesse(schriftgroesse);
				}
				// Schrift-Art fuer diese Nachricht anpassen ?
				if ( applet.getParameter("schriftart"+nr) != null ) {
					String schriftart = applet.getParameter("schriftart"+nr);
					if (  schriftart != null ) nachrichten[nr].setSchriftArt(schriftart);
				}
				// Schrift-Farbe fuer diese Nachricht anpassen ?
				if ( applet.getParameter("schriftfarbe"+nr) != null ) {
					String schriftfarbe = applet.getParameter("schriftfarbe"+nr);
					if ( schriftfarbe.compareTo("rot")  == 0 ) nachrichten[nr].setSchriftFarbe( Color.RED );
					if ( schriftfarbe.compareTo("blau") == 0 ) nachrichten[nr].setSchriftFarbe( Color.BLUE );
					if ( schriftfarbe.compareTo("gr?n") == 0 ) nachrichten[nr].setSchriftFarbe( Color.GREEN );
					if ( schriftfarbe.compareTo("grau") == 0 ) nachrichten[nr].setSchriftFarbe( Color.GRAY );
					if ( schriftfarbe.compareTo("schwarz") == 0 ) nachrichten[nr].setSchriftFarbe( Color.BLACK );
				}
				// Schrift Kursiv fuer diese Nachricht ?
				if ( applet.getParameter("schriftfett"+nr) != null ) {
					if ( applet.getParameter("schriftfett"+nr).compareTo("1") == 0 )
						nachrichten[nr].setSchriftFett(true);
				}
				// Schrift Fett fuer diese Nachricht ?
				if ( applet.getParameter("schriftkursiv"+nr) != null ) {
					if ( applet.getParameter("schriftkursiv"+nr).compareTo("1") == 0 )
						nachrichten[nr].setSchriftKursiv(true);
				}
			}
		}
		
		// 	Laufrichtung ermitteln 
		if ( (applet.getParameter("laufrichtung")) != null ) {
			if ( (applet.getParameter("laufrichtung")).compareToIgnoreCase("v") == 0 ) {
				laufrichtung = 'v';
			} else  laufrichtung = 'h';
		} else  laufrichtung = Standard.laufrichtung;
		
		// 	Geschwindigkeit ermitteln 
		if ( (applet.getParameter("geschwindigkeit")) != null ) {
				geschwindigkeit = Integer.parseInt( applet.getParameter("geschwindigkeit") );
		} else 	geschwindigkeit = Standard.geschwindigkeit;
	}
	
	public Nachricht[] 	getNachrichten() {
		return nachrichten;
	}
	public char 		getLaufrichtung() {
		return laufrichtung;
	}
	public int 			getGeschwindigkeit() {
		return geschwindigkeit;
	}	
}
