package newsTicker;
import java.awt.Color;
import java.awt.Font;
import java.net.URL;
import java.net.MalformedURLException;

public class Nachricht {

	private String 	titel;
	private URL	   	link;
	private Color  	schriftFarbe;
	private String 	schriftArt;
	private byte   	schriftStil;
	private int 	schriftGroesse,
					posX,  posY,
					hoehe, breite;
	
	// Konstruktor mit dem Nachrichten-Titel als einzigen Parameter   
	public Nachricht( String titel ) {
		this.titel = titel;
		setSchriftGroesse( Standard.schriftGroesse );
		setSchriftFarbe( Standard.schriftFarbe );
		setSchriftStil( Standard.schriftStil );
		setSchriftArt( Standard.schriftArt );
		setPosition( -100, -100 );
		berechneGroesse();
	}

	// Konstruktor mit den beiden Parametern "Titel" & "Link"
	public Nachricht( String titel, String link ) {
		this( titel );
		setLink( link );
	}

	public String 	getTitel() {
		return titel;
	}

	public void		setLink( String link) {
		try { this.link = new URL(link); } 
		catch ( MalformedURLException e ) { System.out.println("Fehlerhafte URL\n"+e.getLocalizedMessage() ); return; }
	}
	public URL 		getLink() {
		return link;
	}

	private void 	berechneGroesse() {
		breite = schriftGroesse * 2 / 3 * titel.length();
		hoehe  = schriftGroesse;
	}
	public int 		getBreite() {
		return breite;
	}
	public int 		getHoehe() {
		return hoehe;
	}

	public void 	setPosition( int x, int y ) {
		posX = x;
		posY = y;		
	}
	public void 	verschieben( int deltaX, int deltaY ) {
		posX += deltaX;
		posY += deltaY;
	}
	public int 		getX() {
		return posX;
	}
	public int 		getY() {
		return posY;
	}

	public boolean 	treffer( double x, double y ) {
		if ( x  >  posX   &&   x  <  posX + breite && 
			 y  <  posY   &&   y  >  posY - hoehe ) {
			return true;
		} else { 
			return false; 
		}
	}

	public void 	setSchriftKursiv( boolean setKursiv ) {
		if (setKursiv) { // Schrift KURSIV
			switch( schriftStil ) {
        		case Font.PLAIN:  	schriftStil = Font.ITALIC;            	break;
        		case Font.BOLD: 	schriftStil = Font.BOLD + Font.ITALIC; 	break;
			}
		} else { // Schrift NICHT KURSIV
			switch( schriftStil ) {
    			case Font.ITALIC:   			schriftStil = Font.PLAIN; 	break;
    			case Font.BOLD + Font.ITALIC: 	schriftStil = Font.BOLD;  	break;
			}
		}
	}	
	public void 	setSchriftFett( boolean setFett ) {
		if (setFett) { // Schrift FETT
			switch( schriftStil ) {
        		case Font.PLAIN:  	schriftStil = Font.BOLD;               	break;
        		case Font.ITALIC: 	schriftStil = Font.BOLD + Font.ITALIC; 	break;
			}
		} else { // Schrift NICHT FETT
			switch( schriftStil ) {
    			case Font.BOLD:   			  schriftStil = Font.PLAIN; 	break;
    			case Font.BOLD + Font.ITALIC: schriftStil = Font.ITALIC; 	break;
			}
		}
	}
	public void 	setSchriftStil( byte schriftStil ) {
		this.schriftStil = schriftStil;
	}
	public byte 	getSchriftStil() {
		return schriftStil;
	}

	public void 	setSchriftArt( String schriftArt ) {
		this.schriftArt = schriftArt;
	}
	public String 	getSchriftArt( ) {
		return schriftArt;
	}	
	
	public void 	setSchriftFarbe( Color schriftFarbe ) {
		this.schriftFarbe = schriftFarbe;
	}
	public Color 	getSchriftFarbe() {
		return schriftFarbe;
	}

	public void 	setSchriftGroesse( int schriftGroesse ) {
		this.schriftGroesse = schriftGroesse;
		berechneGroesse();
	}
	public int 		getSchriftGroesse() {
		return schriftGroesse;
	}
}