package newsTicker;
import java.io.*;
import org.xml.sax.*;
import org.w3c.dom.*;
import javax.xml.parsers.*;

public class XMLParser {

	static  Document document;
	private Nachricht[] nachricht;
	private int schriftgroessenVorgabe;
    
    public XMLParser( String dateiName, int schriftgroessenVorgabe ) {
    	this.schriftgroessenVorgabe = schriftgroessenVorgabe;
    	parseDatei(dateiName);
    	parseNachrichten();
    }

    public void  parseDatei( String dateiName ) {
        try {
            DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
            factory.setNamespaceAware(true);
            DocumentBuilder builder = factory.newDocumentBuilder();
            document = builder.parse( dateiName );
        }catch (SAXParseException error) {
        	System.out.println("\nParse-Fehler in Zeile: " + error.getLineNumber() + " - Datei: " + error.getSystemId());
        	System.out.println("\n" + error.getMessage() );
        }catch (ParserConfigurationException pce) {
        	pce.printStackTrace();
        }catch (IOException ioe) {
        	ioe.printStackTrace();
        }catch (Throwable t) {
        	t.printStackTrace();
        }            	
    }
    public void  parseNachrichten() {
        int 		unterTagsAnzahl;
        int 		anzahlNachrichten;
        Node 		itemTag;
        NodeList 	unterTags;
        NodeList 	itemTags;
        
        itemTags = document.getElementsByTagName("item");
        // Ermitteln der Anzahl und anlegen der Nachrichten
        anzahlNachrichten = itemTags.getLength();
        nachricht = new Nachricht[anzahlNachrichten];

        // Schleife fuer alle "item"-Tags/-Bloecke in der XML-Datei
        for (int itemNr=0; itemNr < anzahlNachrichten; itemNr++) {
        	unterTags = itemTags.item(itemNr).getChildNodes();
            // Schleife fuer alle (2) Tags innerhalb eines "item"-Blocks
            for (int nr=0; nr < unterTags.getLength(); nr++) {
            	itemTag = unterTags.item(nr);		
                // Wenn das aktuelle Tag ein Titel- oder Link-Tag ist: auslesen
                if ( itemTag.getNodeType() == Node.ELEMENT_NODE ) {
                	if (itemTag.getNodeName() == "title") {
                		nachricht[itemNr] = new Nachricht( itemTag.getFirstChild().getNodeValue() );
                		nachricht[itemNr].setSchriftGroesse(schriftgroessenVorgabe);
                	}
                	if (itemTag.getNodeName() == "link" )  
                		nachricht[itemNr].setLink( itemTag.getFirstChild().getNodeValue() );
                }
            }
        }
    }

	public Nachricht[] 	getNachrichten() {
		return nachricht;
	}
}

